#Bug.py
from Tools import *

class Bug:
    def __init__(self, number, xPos, yPos, worldXSize = 80, worldYSize = 80):
        # the environment
        self.number = number
        self.worldXSize = worldXSize
        self.worldYSize = worldYSize
        # the bug
        self.xPos = xPos
        self.yPos = yPos
        print "Bug number ", self.number, \
     	      " has been created at ", self.xPos, ", ", self.yPos

    # eating (to be developed)
    def eat(self):
        print "I'm agent %2d: " % self.number,
        print "nothing to eat here!"

    # dancing
    def dance(self):
        print "I'm agent %2d: " % self.number,
        print "it's not time to dance!"

    # the action, now jumping
    def randomWalk(self,**k):
        print "bug # %2d moving" % self.number
        self.jump=k["jump"]
        dx=randomMove(self.jump)
        self.xPos +=dx
        dy=randomMove(self.jump)
        self.yPos += dy
        self.xPos = (self.xPos + self.worldXSize) % self.worldXSize
        self.yPos = (self.yPos + self.worldYSize) % self.worldYSize

        if abs(dx) > 4 and abs(dy) > 4 :
    
       # modify actionGroup "move"
            actionGroup=actionDictionary.get("move","none")
                                # in case, return "none"
        
            if actionGroup=="none": print "warning, actionGroup not found "+\
                            "in agent "+ str(self.number)
            
            else: actionGroup.setLocalCode(actionGroup.getLocalCode()+\
                            "print 'agent %d made a big jump';" % self.number)

    # report
    def reportPosition(self):
        print "Bug number ", self.number, " moved to X = ", \
               self.xPos, " Y = ", self.yPos

    # methods for Tk graphic applications
    def getXPos(self):
        return self.xPos

    def getYPos(self):
        return self.yPos

    def setGraphicItem(self, grI):
        self.graphicItem=grI

    def getGraphicItem(self):
        return self.graphicItem

# returns -1, 0, 1  with equal probability
def randomMove(jump):
    return random.randint(-1, 1)*jump
